﻿package com.nosuch {
	public class ActionBehaviour {
		
		public var LeaveTrail:Boolean = false;
		public var AnimateTrail:Boolean = false;
		public var RandomColor:Boolean = false;
		public var ConstantColorChange:Boolean = false;
		public var AutoAngle:Boolean = false;
		
		public var NumMaxSprites:uint = 100;
		public var _NumBlurX:uint = 0;
		public var _NumBlurY:uint = 0;
		public var NumScaleX:uint = 32;
		public var NumScaleY:uint = 32;
		public var NumAngleSpeed:uint = 64;
		public var NumRandomAmount:uint = 64;
		public var NumAlpha:uint = 64;
		public var NumEase:uint = 0.0;
		public var NumDamp:uint = 0.0;
		
		public var Sprite01:Boolean = true;
		public var Sprite02:Boolean = false;
		public var Sprite03:Boolean = false;
		public var Sprite04:Boolean = false;
		public var Sprite05:Boolean = false;
		public var Sprite06:Boolean = false;
		public var Sprite07:Boolean = false;
		public var Sprite08:Boolean = false;
		public var Sprite09:Boolean = false;
		public var Sprite10:Boolean = false;
		public var Sprite11:Boolean = false;
		public var Sprite12:Boolean = false;
		public var Sprite13:Boolean = false;
		public var Sprite14:Boolean = false;
		public var Sprite15:Boolean = false;
		public var Sprite16:Boolean = false;
		public var Colors01:Boolean = true;
		public var Colors02:Boolean = false;
		public var Colors03:Boolean = false;
		public var Colors04:Boolean = false;
		public var Colors05:Boolean = false;
	
		public var _blur:BlurController;

		public var spriteNames:Array = [
				"thistle01",
				"thistle02",
				"thistle03",
				"thistle04",
				
				"thistle05",
				"thistle06",
				"thistle06",
				"cBlossom01",
				"cBlossom02",
				"snowtree01",
				"snowtree02",
				
				"snowtree03",
				"snowtree04",
				"snowtree05",
				"mapleLeaf01",
				
				"mapleLeaf02"
				];
		

		
		public var allspriteNames:Array = [
				"daisy01",
				"shell02",
				"shell03",
				"shell01",
				
				"cBlossom01",
				"cBlossom02",
				"cloud01",
				"cloud02",
				
				"fan01",
				"foil03",
				"foil04",
				"heart",
				
				"mapleLeaf01",
				"mapleLeaf02",
				"peasant02",
				"umbrella01"
				];
		
		public var colorArrays:Array = [
			[0x468371,0x4F7665,0x345143,0x2C463A,0x49685A,0x336754,0x43564B,0x397763,0x104C41,0x186751,0x1A7E74,0x12362C,0x38362D,0x285B4F,0x555E55,0x125A56],
			[0xED9117,0xDA1508,0xA5170B,0xA15218,0xD1730D,0xF07110,0xCD3F08,0xF5762A,0xCF742C,0xCF4E2E,0xF34926],
			[0xFF0000,0xCC0000,0x990000],
			[0x00FF00,0x00CC00,0x009900],
			[0x0000FF,0x0000CC,0x000099]
			];

		
		public function ActionBehaviour(blur:BlurController):void {
			_blur = blur;
		}
		
		public function getColorArray():Array {
			if ( RandomColor ) {
				var a:Array = new Array();
				for ( var i=0; i<10; i++ ) {
					var r:uint = Math.floor(Math.random() * 256);
					var g:uint = Math.floor(Math.random() * 256);
					var b:uint = Math.floor(Math.random() * 256);
					a.push(r * 0x10000 + g * 0x100 + b);
				}
				// trace("Rand colors = ",a);
				return a;
			}
			if ( Colors01 ) return colorArrays[0];
			if ( Colors02 ) return colorArrays[1];
			if ( Colors03 ) return colorArrays[2];
			if ( Colors04 ) return colorArrays[3];
			if ( Colors05 ) return colorArrays[4];
			return colorArrays[0];
		}
		
		public function set NumBlurX(v:uint):void {
			// trace("ACTIONBEHAVIOUR set NumBlurX v=",v);
			_blur.setBlurX(v / 10.0);
			_NumBlurX = v;
		}
		public function get NumBlurX():uint {
			return _NumBlurX;
		}
		public function set NumBlurY(v:uint):void {
			// trace("ACTIONBEHAVIOUR set NumBlurX v=",v);
			_blur.setBlurY(v / 10.0);
			_NumBlurY = v;
		}
		public function get NumBlurY():uint {
			return _NumBlurY;
		}
		public function get spriteName():String {
			var a:Array = new Array();
			if ( Sprite01 ) { a.push(spriteNames[0]); }
			if ( Sprite02 ) { a.push(spriteNames[1]); }
			if ( Sprite03 ) { a.push(spriteNames[2]); }
			if ( Sprite04 ) { a.push(spriteNames[3]); }
			if ( Sprite05 ) { a.push(spriteNames[4]); }
			if ( Sprite06 ) { a.push(spriteNames[5]); }
			if ( Sprite07 ) { a.push(spriteNames[6]); }
			if ( Sprite08 ) { a.push(spriteNames[7]); }
			if ( Sprite09 ) { a.push(spriteNames[8]); }
			if ( Sprite10 ) { a.push(spriteNames[9]); }
			if ( Sprite11 ) { a.push(spriteNames[10]); }
			if ( Sprite12 ) { a.push(spriteNames[11]); }
			if ( Sprite13 ) { a.push(spriteNames[12]); }
			if ( Sprite14 ) { a.push(spriteNames[13]); }
			if ( Sprite15 ) { a.push(spriteNames[14]); }
			if ( Sprite16 ) { a.push(spriteNames[15]); }
			var i:uint = Math.floor(Math.random() * a.length);
			// trace("behaviour spritename=",a[i], "  arr=",a);
			return a[i];
		}
	}
}