﻿ package com.nosuch {
	 
	 import flash.display.DisplayObjectContainer;
	 import flash.display.Bitmap;
	 import flash.display.BitmapData;
	 import flash.events.Event;
	 
	 public class BitmapController {
		 
		private var _bitmap:Bitmap;
		private var _container:DisplayObjectContainer;
		private var _bitmapData:BitmapData;
		
		public var myBitmapX:Number;
		public var myBitmapY:Number;
		public var myBitmapWidth:Number;
		public var myBitmapHeight:Number;
		public var myBitmapTransparency:Boolean;
		public var myBitmapColor:uint;
		 
		public function BitmapController(bitmap:Bitmap, container:DisplayObjectContainer):void {
			_bitmap = bitmap;
			_container = container;
		}
		
		public function createBitmap():void {
			_bitmapData = new BitmapData(myBitmapWidth, myBitmapHeight, myBitmapTransparency, myBitmapColor);
			_bitmap.x = myBitmapX;
			_bitmap.y = myBitmapY;
		}
		
		public function startPaint():void {
			_container.addEventListener(Event.ENTER_FRAME, paintBitmap);
		}
		
		public function get bitmapData():BitmapData {
			return _bitmapData;
		}
		
		public function stopPaint():void {
			_container.removeEventListener(Event.ENTER_FRAME, paintBitmap);
		}
		
		public function paintBitmap(evt:Event):void {
			// _container.rotation = 0.1;
			_bitmapData.draw(_container);
			_bitmap.bitmapData = _bitmapData;
		}
	 }
}
 