﻿package com.nosuch {
	import flash.geom.Point;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.utils.*;
	
	public class BlurController {
		
		private var _intervalID:uint;
		private var _bitmapData:BitmapData;
		private var _filter:BlurFilter;
		
		public var myBlurX:Number;
		public var myBlurY:Number;
		public var myBlurQuality:Number;
	
		public function BlurController():void {
		}
		public function startBluring(interval:Number, bitmapData:BitmapData):void {
			_intervalID = setInterval(startNextBlur, interval);
			_bitmapData = bitmapData;
			_filter = new BlurFilter(myBlurX, myBlurY, myBlurQuality);
		}
		private function startNextBlur():void {
			_bitmapData.applyFilter(_bitmapData, _bitmapData.rect, new Point(0,0), _filter);
		}
		public function stopBlur():void {
			clearInterval(_intervalID);
		}
		public function setBlurX(v:Number) {
			// trace("setBlurx! = ",v);
			_filter.blurX = v;
		}
		public function setBlurY(v:Number) {
			// trace("setBlury! = ",v);
			_filter.blurY = v;
		}
	}
}