﻿package com.nosuch {
	import flash.geom.ColorTransform;
	import flash.display.InteractiveObject;
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	
	public class ColorController {
		
		private var _colorList:Array;
		
		public function ColorController(colorList:Array):void {
			_colorList = colorList;
			// trace(colorList);
		}
		
		public function colorize(itemList:Array):void {
			if ( itemList == null ) {
				return;
			}
			var i:uint;
			var j:uint;
			var numItems:uint = itemList.length;
			var max:uint;
			var item:DisplayObjectContainer;
			var fill:DisplayObject;
			var colorTransform:ColorTransform;
			
			for (i=0; i<numItems; i++) {
				item = itemList[i] as DisplayObjectContainer;
				max = item.numChildren;
				for (j=0; j<max; j++) {
					fill = item.getChildAt(j);
					if (fill is InteractiveObject) {
							colorTransform = fill.transform.colorTransform;
							colorTransform.color = _colorList[Math.floor(Math.random() * _colorList.length)];
							fill.transform.colorTransform = colorTransform;
					}
				}
			}
		}
	}
	
}