﻿package com.nosuch
{
	public class FingerEvent extends NthEvent
	{
		public static const DOWN:String  = "DOWN";
		public static const UP:String = "UP";
		public static const DRAG:String = "DRAG";

		public function FingerEvent(x:XML,tm:Number)
		{
			var t:String = x.localName();
			if ( t == "finger_up" ) {
				t = UP;
			} else if ( t == "finger_down" ) {
				t = DOWN;
			} else if ( t == "finger_drag" ) {
				t = DRAG;
			}
			// trace("FingerEvent t="+t);
			super(t,x,tm)
		}
		public override function toString():String {
			return "FingerEvent[type="+this.type+" uid="+fingerUID()+" x="+x()+" y="+y()+" p="+proximity()+"]";
		}
		public function fingerUID():String {
			// Returns unique id string across all devices
			return xml.attribute("uid");
		}
    	public function x():Number {
    		return xml.attribute("x");
    	}
    	public function y():Number {
    		return xml.attribute("y");
    	}
    	public function proximity():Number {
    		return xml.attribute("prox");
    	}
	}
}